% Copyright Pieter Abbeel
%

function [z, coords] = beam_range_finder_sampler_gridworld(x0, y0, theta0, gridworld, laser_model)


for i=1:length(laser_model.laser_angles)
    
	% I provided you with the raycast function, it has some limitations and
	% is not superfast, but it is good enough for this assignment (of
	% course I won't object to you improving it)
	% [d, coords] = raycast coordinates, do not account for laser length limit or noise introduced
    [d(i,1), coords{i}] = raycast(x0, y0, theta0, laser_model.laser_angles(i), gridworld); 
    
	% z : accounts for laser length limit and has noise
    % YOU have to implement beam_range_finder_sampler
	[z(i,1), hit_type] = beam_range_finder_sampler(d(i,1), laser_model);

end

