% Copyright Pieter Abbeel
%

function draw_gridworld(gridworld, x_res, y_res)

if (nargin < 3)
	x_res = 1;
	y_res = 1;
end

[m,n] = size(gridworld);

hold on; axis equal;

for i=1:m
    for j=1:n
        draw_rectangle( (i-1)*x_res, i*x_res, (j-1)*y_res, j*y_res, gridworld(i,j));
    end
end



function draw_rectangle(x0, x1, y0, y1, filled)


if(filled)
    fill([x0 x1 x1 x0], [y0 y0 y1 y1], (1-filled)*[1 1 1] + filled*[0 0 0]);
else
    %fill([x0 x1 x1 x0], [y0 y0 y1 y1], 'w');
end
