% Copyright Pieter Abbeel
%
% 3.5 Particle Filter for Known Initial State
%
% representative timing result:
% tic; p3_5_particle_filter; toc
% Elapsed time is 32.421763 seconds.
% -- this is for "rooms_world_path1", 10 particles
%
% let's run a particle filter for known initial state, and see if it can
% track the true trajectory reasonably well:

% run the "basic" particle filter, which for each time step:
% samples from the dynamics model,
% reweights based on the likelihood of the measurements
% randomly resamples from the weighted particles according to their weights

% compare using the standard weight updates with making the measurements
% "weaker" by multiplying with p(z|x)^a for some a with 0 < a < 1

clear; clc; close all;


% commenting in/out selects the world/sensory sequence to work with:

%load simple_world_path1;
load rooms_world_path1;
%load loops_world_path1;

% this file only contains initial state, you will generate the estimate of
% the path and need to include the resulting plot in your report:
% note when running with the file below being loaded, the variable "x" will
% not be available 

%load rooms_world_init_state_only  


T = size(z,2);

%% visualize true path

figure; axis equal; hold on;
draw_gridworld(gridworld);
if(exist('x'))
	plot(x(1,:), x(2,:), 'x-');
end

% YOUR code here






