% Copyright Pieter Abbeel
%
% 3.6 Particle Filter --- we will consider multiple hypotheses for initial state 
%
% Representative running time:
% tic; p3_6_multiple_hypotheses_low_variance_sampling; toc
% Elapsed time is 13.724286 seconds.
% -- this was for 100 particles, running up to time t=20


% study how many samples are needed to typically get the right result (what
% is the right result?!)

% compare the basic particle filter's with the low variance resampling variant
% compare using the standard weight updates with making the measurements
% "weaker" by multiplying with p(z|x)^a for some a with 0 < a < 1

% you might want to have your experimental study be over a shorter time
% interval than the full data (as it might take a bit long to run over the
% full data).  That's OK, but make sure to explain at what time you cut it
% off, and why you believe it's OK to do so per drawing conclusions about
% the variants considered.


clear; clc; close all;



load loops_world_path0;


T = size(z,2);

%% visualize true path

figure; axis equal; hold on;
draw_gridworld(gridworld);
if(exist('x'))
	plot(x(1,:), x(2,:), 'x-');
end

[m,n] = size(gridworld);


%% run particle filter for localization


%% init:
n_particles = 100; %YOU should vary this
weights = 1/n_particles*ones(1,n_particles);
init_hypotheses = [2 2 pi/2;  8 14 -pi/2 ; 2 8 0; 8 8 pi]'; 
particles = repmat(init_hypotheses, 1, n_particles/4);

%% visualize initial particles

figure; axis equal; hold on;
draw_gridworld(gridworld);
plot(particles(1,:), particles(2,:), '.');


%% YOUR code here

